% CSC321 Tutorial 2 simple machinie learning with gradient descent and
% percetron

clear all;

cd ~/Desktop/CSC321/Tutorials/T2/matlab_code

%% regressiondata.m
X = randn(2,1000);          %produce random inputs in 2d
w_init = [1;1];                  %define some linear function
n = randn(1,1000)*0.1;      %produce noise in 1d
Y = w_init'*X + n;               %apply function and add noise
scatter3(X(1,:),X(2,:),Y);  %show the result


%% learn weight using graddescent_vectorized.m
[w_learned, err] = graddescent_vectorized_YL(X, Y, w_init);


%% visualize prediction results
plot(err, '.r');

figure;
Y_hat = w_learned'*X;
scatter3(X(1,:),X(2,:),Y, 'r');hold on;
scatter3(X(1,:),X(2,:),Y_hat, 'b');

figure;
plot(Y_hat, '.b');
hold on;
plot(Y, '.r');
hold off;


%% Perceptron demo

clear all;

%% classdata1.m
%PRODUCE SOME DATA FOR CLASSIFICATION (TWO GAUSSIANS)

X = [randn(3,200)-ones(3,200)*2.0 ...
     randn(3,200)+ones(3,200)*2.0];   %produce inputs
Y = [ones(1,200)*(-1), ones(1,200)];  %produce corresponding labels

figure;
scatter3(X(1,:),X(2,:),X(3,:), 80, Y, 'filled');

%% random guessing
w = randn(3,1);
Y_random = sign(w'*X);

figure;
scatter3(X(1,:),X(2,:),X(3,:),80, Y_random, 'filled');
hold on;
plot3([0 w(1)], [0 w(2)], [0 w(3)], 'k'); %show w
hold off;
err_rate = sum(Y_random~=Y)/length(Y);  %error rate
disp(err_rate);

%% Perceptron learning
w_init = randn(3,1);

Y_random = sign(w_init'*X);
err_init = sum(Y_random~=Y)/length(Y);  %initial error rate

[w_learned, err] = perceptron_YL(X, Y, w_init);

plot([err_init err], '.r');

Y_hat = sign(w_learned'*X);

figure;
scatter3(X(1,:),X(2,:),X(3,:),80, Y_hat, 'filled');
hold on;
plot3([0 w_learned(1)], [0 w_learned(2)], [0 w_learned(3)], 'k'); %show w
hold off;
err_rate = sum(Y_hat~=Y)/length(Y);  %error rate
disp(err_rate);


% testing cases
X_test = [randn(3,200)-ones(3,200)*2.0 ...
     randn(3,200)+ones(3,200)*2.0];   %produce inputs
 
Y_test = [ones(1,200)*(-1), ones(1,200)];  %produce corresponding labels

Y_test_hat = sign(w_learned'*X_test);

figure;
scatter3(X_test(1,:),X_test(2,:),X_test(3,:), 80, Y_test, 'filled');
figure;
scatter3(X_test(1,:),X_test(2,:),X_test(3,:),80, Y_test_hat, 'filled');
hold on;
plot3([0 w_learned(1)], [0 w_learned(2)], [0 w_learned(3)], 'k'); %show w
hold off;

err_rate = sum(Y_test_hat~=Y_test)/length(Y_test);  %error rate
disp(err_rate);





